package eu.mhsl.minecraft.bungeequeue.command;

import eu.mhsl.minecraft.bungeequeue.BungeeQueue;
import net.md_5.bungee.api.ChatColor;
import net.md_5.bungee.api.CommandSender;
import net.md_5.bungee.api.ProxyServer;
import net.md_5.bungee.api.chat.ComponentBuilder;
import net.md_5.bungee.api.connection.ProxiedPlayer;
import net.md_5.bungee.api.plugin.Command;

import java.util.*;
import java.util.concurrent.TimeUnit;
import java.util.stream.Collectors;

public class MaxPlayers extends Command {
    public MaxPlayers() {
        super("maxplayers", "bungeequeue.queue");
    }

    @Override
    public void execute(CommandSender p, String[] strings) {
        if(strings.length >= 1) {
            switch (strings[0]) {
                case "set":
                    if(strings.length == 2) {
                        BungeeQueue.maxPlayers = Integer.parseInt(strings[1]);
                        BungeeQueue.conf.set("maxPlayers", BungeeQueue.maxPlayers);
                        BungeeQueue.saveConfig();
                        p.sendMessage(new ComponentBuilder("Die Maximale Spieleranzahl wurde auf " + strings[1] + " gesetzt.").color(ChatColor.GREEN).create());
                    } else p.sendMessage(new ComponentBuilder("Bitte definiere die maximale Spieleranzahl: /maxplayers set <amount> ").color(ChatColor.RED).create());
                    break;
                case "query":
                    p.sendMessage(new ComponentBuilder("Die aktuelle Spieleranzahl ist " + BungeeQueue.maxPlayers).color(ChatColor.GREEN)
                            .append("\n... davon belegt " + BungeeQueue.targetServer.getPlayers().size()).color(ChatColor.GREEN)
                            .append("\nDu kannst 'enforce' nutzen, um eine Überbelegung zu verhindern.").color(ChatColor.RED)
                            .create()
                    );
                    break;
                case "enforce":
                    if(enforceMaxPlayer(strings.length == 2 ? Integer.parseInt(strings[1]) : BungeeQueue.conf.getInt("enforceDefaultTimeout")))
                        p.sendMessage(new ComponentBuilder("Die maximale Spieleranzahl wird durchgesetzt...").color(ChatColor.GREEN).create());
                    else
                        p.sendMessage(new ComponentBuilder("Die maximale Spieleranzahl ist nicht erreicht und kann somit auch nicht durchgesetzt werden!").color(ChatColor.RED).create());
                    break;
                case "bypass":
                    if(strings.length > 2) {
                        p.sendMessage(new ComponentBuilder("Bitte definiere nur einen Nutzernamen").color(ChatColor.RED).create());
                    } else if(strings.length == 2) {
                        ProxiedPlayer targetPlayer = ProxyServer.getInstance().getPlayer(strings[1]);
                        targetPlayer.connect(BungeeQueue.targetServer);
                        p.sendMessage(new ComponentBuilder(targetPlayer.getName() + " wurde an der Queue vorbeigelassen!").color(ChatColor.GREEN).create());
                        targetPlayer.sendMessage(new ComponentBuilder("Du wurdest von einem Administrator vorzeitig auf den Server verschoben!").color(ChatColor.GREEN).create());
                    } else {
                        ((ProxiedPlayer) p).connect(BungeeQueue.targetServer);
                        p.sendMessage(new ComponentBuilder("Du wurdest per Befehl von der Queue befreit!").color(ChatColor.GREEN).create());
                    }
                    break;
                default:
                    p.sendMessage(new ComponentBuilder("Invalide Command-Syntax, valide argumente sind <query | set <amount> | enforce>").color(ChatColor.RED).create());
            }
        } else p.sendMessage(new ComponentBuilder("Die Syntax des commands ist /maxplayers <query | set <amount> | enforce>").color(ChatColor.RED).create());
    }

    private boolean enforceMaxPlayer(int timeout) {
        List<ProxiedPlayer> evaluatedPlayers = new ArrayList<>();

        int leftOver = BungeeQueue.targetServer.getPlayers().size() - BungeeQueue.maxPlayers;
        if(leftOver <= 0) return false;

        List<ProxiedPlayer> players = new ArrayList<>(BungeeQueue.targetServer.getPlayers());
        Collections.shuffle(players);

        for (int i = 0; i < leftOver; i++) {
            if(BungeeQueue.waitingSince.get(players.get(i)) <= new Date().getTime()-1800000) {
                ProxyServer.getInstance().getLogger().warning("Canceling Maxplayer enforce on Player " + players.get(i).getName() + "!");
                continue;
            }
            evaluatedPlayers.add(players.get(i));

            players.get(i).sendMessage(new ComponentBuilder("\n\n>> Achtung >> \n").bold(true).color(ChatColor.RED)
                    .append("Aufgrund eines zu hohen Spieleraufkommens, das Lags erzeugt, werden zufällige Spieler vom Server gekickt.\n Begebe dich an einen sicheren Ort.\n").color(ChatColor.GOLD)
                    .append("Du wirst in " + timeout + " Sekunden in die Warteschlange verschoben!\n\n").color(ChatColor.RED)
                    .create()
            );
        }

        ProxyServer.getInstance().getScheduler().schedule(BungeeQueue.plugin, new Runnable() {
            @Override
            public void run() {
                for(ProxiedPlayer p : evaluatedPlayers) {
                    p.connect(BungeeQueue.queueServer);
                    p.sendMessage(new ComponentBuilder("Du wurdest wie angekündigt aufgrund eines zu hohen Spieleraufkommens zurück in die Warteschlange versetzt. Die Auswahl Dich zu verschieben war zufällig. Sorry!").color(ChatColor.GOLD).create());
                }
            }
        }, timeout, TimeUnit.SECONDS);

        return true;
    }
}
